// -*- c++ -*-
#include <iostream>
#include <fstream>
#include <list>

#include <hugo/dimacs.h>
#include <bfs_dfs_misc.h>
#include <list_graph.h>
#include <hugo/graph_wrapper.h>

using namespace hugo;

int main() {
  typedef ListGraph Graph;
  Graph g;
  readDimacs(std::cin, g); 
  {
    std::list<Graph::Node> l;
    topSort(g, l);
    std::cout << "Leaving order of dfs which is pretopological..." << std::endl;
    for(std::list<Graph::Node>::const_iterator i=l.begin(); i!=l.end(); ++i) {
      std::cout << *i << " ";
    }
    std::cout << std::endl;
  }
  
  {
    typedef RevGraphWrapper<Graph> GW;
    GW gw(g);
    std::list<GW::Node> l;
    topSort(gw, l);
    std::cout << "Same in the revered oriented graph..." << std::endl;
    for(std::list<GW::Node>::const_iterator i=l.begin(); i!=l.end(); ++i) {
      std::cout << *i << " ";
    }
    std::cout << std::endl;
  }

  return 0;
}
